-- RealLightShadows
--
-- # Author:  Rival
-- # date: 31.10.2022

Lights.onLoad = Utils.appendedFunction(Lights.onLoad, function(self, ...)
	local shadowMapResolution = 256
	setMaxNumShadowLights(100)

	local spec = self.spec_lights
	for _,light in pairs(spec.realLights.high.realLights) do -- adjust only high profile lights
		if getLightRange(light.node) > 7 then
			setLightShadowMap(light.node, true, shadowMapResolution)
		end
		local childrenCount = getNumOfChildren(light.node)
		for i=0, childrenCount-1 do
			local child = getChildAt(light.node, i)
			if getHasClassId(child, ClassIds.LIGHT_SOURCE) then
				if getLightRange(child) > 7 then
					setLightShadowMap(child, true, shadowMapResolution)
				end
			end
		end
	end
end)
